Angular Floating Labels Component

Floating Labels

Angular floating label component. Create beautifully simple form labels that float over your input fields.

Available in Other JavaScript Frameworks

CoreUI Angular Floating Labels Component is also available for Bootstrap, React, and Vue. Explore framework-specific implementations below:

Example

Wrap a pair of cFormControl and label elements in cFormControl to enable floating labels with textual form fields. A placeholder is required on each input as our method of CSS-only floating labels uses the :placeholder-shown pseudo-element. Also note that the cFormControl must come first so we can utilize a sibling selector (ex., ~).

import { Component } from '@angular/core';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { FormControlDirective, FormFloatingDirective, FormLabelDirective } from '@coreui/angular';

@Component({
  selector: 'docs-floating-labels',
  templateUrl: './floating-labels.component.html',
  imports: [ReactiveFormsModule, FormsModule, FormFloatingDirective, FormControlDirective, FormLabelDirective]
})
export class FloatingLabelsComponent {}
<form>
  <div [cFormFloating]="true" class="mb-3">
    <input cFormControl id="floatingInput" placeholder="[email protected]" type="email" />
    <label cLabel for="floatingInput">Email address</label>
  </div>
  <div cFormFloating>
    <input cFormControl id="floatingPassword" placeholder="Password" type="password" autocomplete="off" />
    <label cLabel for="floatingPassword">Password</label>
  </div>
</form>

When there’s a value already defined, cLabel will automatically adjust to their floated position.

import { Component } from '@angular/core';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { FormControlDirective, FormFloatingDirective, FormLabelDirective } from '@coreui/angular';

@Component({
  selector: 'docs-floating-labels-2',
  templateUrl: './floating-labels-2.component.html',
  imports: [ReactiveFormsModule, FormsModule, FormFloatingDirective, FormControlDirective, FormLabelDirective]
})
export class FloatingLabels2Component {}
<form cFormFloating>
  <input
    cFormControl
    id="floatingInputValue"
    type="email"
    value="[email protected]"
    placeholder
  />
  <label cLabel for="floatingInputValue">Input with value</label>
</form>

Textareas

By default, textarea will be the same height as input.

import { Component } from '@angular/core';
import { FormControlDirective, FormFloatingDirective, FormLabelDirective } from '@coreui/angular';

@Component({
  selector: 'docs-floating-labels-textareas',
  templateUrl: './floating-labels-textareas.component.html',
  imports: [FormFloatingDirective, FormControlDirective, FormLabelDirective]
})
export class FloatingLabelsTextareasComponent {}
<div cFormFloating>
  <textarea cFormControl id="floatingTextarea" placeholder="Leave a comment here"></textarea>
  <label cLabel for="floatingTextarea">Comments</label>
</div>

To set a custom height on your textarea, do not use the rows attribute. Instead, set an explicit height (either inline or via custom CSS).

import { NgStyle } from '@angular/common';
import { Component } from '@angular/core';
import { FormControlDirective, FormFloatingDirective, FormLabelDirective } from '@coreui/angular';

@Component({
  selector: 'docs-floating-labels-textareas-2',
  templateUrl: './floating-labels-textareas-2.component.html',
  imports: [FormFloatingDirective, FormControlDirective, NgStyle, FormLabelDirective]
})
export class FloatingLabelsTextareas2Component {}
<div cFormFloating>
  <textarea [ngStyle]="{ 'height.px': 100 }" cFormControl id="floatingTextarea2" placeholder="Leave a comment here"></textarea>
  <label cLabel for="floatingTextarea2">Comments</label>
</div>

Selects

Other than input, floating labels are only available on cSelect. They work in the same way, but unlike input, it always shows the cLabel in its floated state.

Selects with size and multiple are not supported.

import { Component } from '@angular/core';
import { ReactiveFormsModule } from '@angular/forms';
import { FormFloatingDirective, FormLabelDirective, FormSelectDirective } from '@coreui/angular';

@Component({
  selector: 'docs-floating-labels-selects',
  templateUrl: './floating-labels-selects.component.html',
  imports: [FormFloatingDirective, FormSelectDirective, ReactiveFormsModule, FormLabelDirective]
})
export class FloatingLabelsSelectsComponent {}
<div cFormFloating>
  <select cSelect id="floatingSelect">
    <option>Open this select menu</option>
    <option value="1">One</option>
    <option value="2">Two</option>
    <option value="3">Three</option>
  </select>
  <label cLabel for="floatingSelect">Works with selects</label>
</div>

Layout

When working with the CoreUI for Bootstrap grid system, be sure to place form elements within column classes.

import { Component } from '@angular/core';
import { ReactiveFormsModule } from '@angular/forms';
import {
  ColComponent,
  FormControlDirective,
  FormFloatingDirective,
  FormLabelDirective,
  FormSelectDirective,
  GutterDirective,
  RowComponent
} from '@coreui/angular';

@Component({
  selector: 'docs-floating-labels-layout',
  templateUrl: './floating-labels-layout.component.html',
  imports: [
    RowComponent,
    GutterDirective,
    ColComponent,
    FormFloatingDirective,
    FormControlDirective,
    FormLabelDirective,
    FormSelectDirective,
    ReactiveFormsModule
  ]
})
export class FloatingLabelsLayoutComponent {}
<c-row [gutter]="{g: 2}">
  <c-col [md]>
    <div cFormFloating>
      <input
        cFormControl
        id="floatingInputGrid"
        type="email"
        value="[email protected]"
        placeholder
      />
      <label cLabel for="floatingInputGrid">Email address</label>
    </div>
  </c-col>
  <c-col [md]>
    <div cFormFloating>
      <select cSelect id="floatingSelectGrid">
        <option>Open this select menu</option>
        <option value="1">One</option>
        <option value="2">Two</option>
        <option value="3">Three</option>
      </select>
      <label cLabel for="floatingSelectGrid">Works with selects</label>
    </div>
  </c-col>
</c-row>

API reference

Form Module

cFormFloating

directive

jsx
import { FormFloatingDirective } from '@coreui/angular'
PropertyDefaultType
cFormFloatingtrueboolean

Enable floating labels

Vue Floating labels

Floating labels

Vue floating label component. Create beautifully simple form labels that float over your input fields.

Available in Other JavaScript Frameworks

CoreUI Vue Floating labels is also available for Angular, Bootstrap, and React. Explore framework-specific implementations below:

Example

Use floatingLabel property on <CFormInput>, <CFormSelect> or <CFormTextarea> to enable floating labels with textual form fields. A placeholder is required on each <CFormInput>, <CFormSelect> and <CFormTextarea> as our method of CSS-only floating labels uses the :placeholder-shown pseudo-element.

vue
<template>
  <CFormInput
    id="floatingInput"
    class="mb-3"
    type="email"
    floating-label="Email address"
    placeholder="[email protected]"
  />
  <CFormInput
    id="floatingPassword"
    type="password"
    floating-label="Password"
    placeholder="Password"
  />
</template>

<script setup>
import { CFormInput } from '@coreui/vue'
</script>

You can create the same form control by wrapping a pair of <CFormInput> and <CFormLabel> elements in <CFormFloating> to enable floating labels with textual form fields. A placeholder is required on each <CFormInput> as our method of CSS-only floating labels uses the :placeholder-shown pseudo-element. Also, note that the <CFormInput> must come first so we can utilize a sibling selector (e.g., ~).

<CFormFloating class="mb-3">
  <CFormInput type="email" id="floatingInput" placeholder="[email protected]" />
  <CFormLabel for="floatingInput">Email address</CFormLabel>
</CFormFloating>
<CFormFloating>
  <CFormInput type="password" id="floatingPassword" placeholder="Password" />
  <CFormLabel for="exampleFormControlPassword">Password</CFormLabel>
</CFormFloating>

When there’s a value already defined, <CFormLabel>s will automatically adjust to their floated position.

vue
<template>
  <CFormFloating>
    <CFormInput
      id="floatingInputValue"
      type="email"
      floating-label="Input with value"
      placeholder="[email protected]"
      value="[email protected]"
    />
  </CFormFloating>
</template>

<script setup>
import { CFormFloating, CFormInput } from '@coreui/vue'
</script>

Form validation styles also work as expected.

vue
<template>
  <CFormInput
    id="floatingInputInvalid"
    class="mb-3"
    type="email"
    floating-label="Email addresss"
    placeholder="[email protected]"
    valid
    value="[email protected]"
  />
  <CFormInput
    id="floatingInputInvalid"
    type="email"
    invalid
    floating-label="Email addresss"
    placeholder="[email protected]"
    value="[email protected]"
  />
</template>

<script setup>
import { CFormInput } from '@coreui/vue'
</script>

Textareas

By default, <CFormTextarea>s will be the same height as <CFormInput>s.

vue
<template>
  <CFormFloating>
    <CFormTextarea
      id="floatingTextarea"
      floating-label="Comments"
      placeholder="Leave a comment here"
    ></CFormTextarea>
  </CFormFloating>
</template>

<script setup>
import { CFormFloating, CFormTextarea } from '@coreui/vue'
</script>

To set a custom height on your <CFormTextarea>, do not use the rows attribute. Instead, set an explicit height (either inline or via custom CSS).

vue
<template>
  <CFormFloating>
    <CFormTextarea
      id="floatingTextarea2"
      placeholder="Leave a comment here"
      floating-label="Comments"
      style="height: 100px"
    ></CFormTextarea>
  </CFormFloating>
</template>

<script setup>
import { CFormFloating, CFormTextarea } from '@coreui/vue'
</script>

Selects

Other than <CFormInput>, floating labels are only available on <CFormSelect>s. They work in the same way, but unlike <CFormInput>s, they’ll always show the <CFormLabel> in its floated state. Selects with size and multiple are not supported.

vue
<template>
  <CFormFloating>
    <CFormSelect
      id="floatingSelect"
      floating-label="Works with selects"
      aria-label="Floating label select example"
    >
      <option>Open this select menu</option>
      <option value="1">One</option>
      <option value="2">Two</option>
      <option value="3">Three</option>
    </CFormSelect>
  </CFormFloating>
</template>

<script setup>
import { CFormFloating, CFormSelect } from '@coreui/vue'
</script>

Layout

When working with the CoreUI for Bootstrap grid system, be sure to place form elements within column classes.

vue
<template>
  <CRow :xs="{ gutter: 2 }">
    <CCol md>
      <CFormFloating>
        <CFormInput
          id="floatingInputGrid"
          type="email"
          floating-label="Email address"
          placeholder="[email protected]"
          value="[email protected]"
        />
      </CFormFloating>
    </CCol>
    <CCol md>
      <CFormFloating>
        <CFormSelect
          id="floatingSelectGrid"
          floating-label="Works with selects"
          aria-label="Floating label select example"
        >
          <option>Open this select menu</option>
          <option value="1">One</option>
          <option value="2">Two</option>
          <option value="3">Three</option>
        </CFormSelect>
      </CFormFloating>
    </CCol>
  </CRow>
</template>

<script setup>
import { CRow, CCol, CFormFloating, CFormInput, CFormSelect } from '@coreui/vue'
</script>

API

Check out the documentation below for a comprehensive guide to all the props you can use with the components mentioned here.

React Floating labels

Floating labels

React floating label component. Create beautifully simple form labels that float over your input fields.

Available in Other JavaScript Frameworks

CoreUI React Floating labels is also available for Angular, Bootstrap, and Vue. Explore framework-specific implementations below:

Example

Use floatingLabel property on <CFormInput>, <CFormSelect> or <CFormTextarea> to enable floating labels with textual form fields. A placeholder is required on each <CFormInput>, <CFormSelect> and <CFormTextarea> as our method of CSS-only floating labels uses the :placeholder-shown pseudo-element.

import React from 'react'
import { CFormInput } from '@coreui/react'

export const FloatingLabelsExample = () => {
  return (
    <>
      <CFormInput
        type="email"
        id="floatingInput"
        floatingClassName="mb-3"
        floatingLabel="Email address"
        placeholder="[email protected]"
      />
      <CFormInput
        type="password"
        id="floatingPassword"
        floatingLabel="Password"
        placeholder="Password"
      />
    </>
  )
}
import React from 'react'
import { CFormInput } from '@coreui/react'

export const FloatingLabelsExample = () => {
  return (
    <>
      <CFormInput
        type="email"
        id="floatingInput"
        floatingClassName="mb-3"
        floatingLabel="Email address"
        placeholder="[email protected]"
      />
      <CFormInput
        type="password"
        id="floatingPassword"
        floatingLabel="Password"
        placeholder="Password"
      />
    </>
  )
}

You can create the same form control by wrapping a pair of <CFormInput> and <CFormLabel> elements in <CFormFloating> to enable floating labels with textual form fields. A placeholder is required on each <CFormInput> as our method of CSS-only floating labels uses the :placeholder-shown pseudo-element. Also, note that the <CFormInput> must come first so we can utilize a sibling selector (e.g., ~).

<CFormFloating className="mb-3">
  <CFormInput type="email" id="floatingInput" placeholder="[email protected]" />
  <CFormLabel htmlFor="floatingInput">Email address</CFormLabel>
</CFormFloating>
<CFormFloating>
  <CFormInput type="password" id="floatingPassword" placeholder="Password" />
  <CFormLabel htmlFor="exampleFormControlTextarea1">Password</CFormLabel>
</CFormFloating>

When there’s a value already defined, <CFormLabel>s will automatically adjust to their floated position.

import React from 'react'
import { CFormInput } from '@coreui/react'

export const FloatingLabels2Example = () => {
  return (
    <CFormInput
      type="email"
      id="floatingInputValue"
      floatingLabel="Input with value"
      placeholder="[email protected]"
      defaultValue="[email protected]"
    />
  )
}
import React from 'react'
import { CFormInput } from '@coreui/react'

export const FloatingLabels2Example = () => {
  return (
    <CFormInput
      type="email"
      id="floatingInputValue"
      floatingLabel="Input with value"
      placeholder="[email protected]"
      defaultValue="[email protected]"
    />
  )
}

Form validation styles also work as expected.

import React from 'react'
import { CFormInput } from '@coreui/react'

export const FloatingLabelsValidationExample = () => {
  return (
    <>
      <CFormInput
        type="email"
        id="floatingInputValid"
        floatingClassName="mb-3"
        floatingLabel="Email addresss"
        placeholder="[email protected]"
        defaultValue="[email protected]"
        valid
      />
      <CFormInput
        type="email"
        id="floatingInputInvalid"
        floatingLabel="Email addresss"
        placeholder="[email protected]"
        defaultValue="[email protected]"
        invalid
      />
    </>
  )
}
import React from 'react'
import { CFormInput } from '@coreui/react'

export const FloatingLabelsValidationExample = () => {
  return (
    <>
      <CFormInput
        type="email"
        id="floatingInputValid"
        floatingClassName="mb-3"
        floatingLabel="Email addresss"
        placeholder="[email protected]"
        defaultValue="[email protected]"
        valid
      />
      <CFormInput
        type="email"
        id="floatingInputInvalid"
        floatingLabel="Email addresss"
        placeholder="[email protected]"
        defaultValue="[email protected]"
        invalid
      />
    </>
  )
}

Textareas

By default, <CFormTextarea>s will be the same height as <CFormInput>s.

import React from 'react'
import { CFormTextarea } from '@coreui/react'

export const FloatingLabelsTextareaExample = () => {
  return (
    <CFormTextarea
      id="floatingTextarea"
      floatingLabel="Comments"
      placeholder="Leave a comment here"
    ></CFormTextarea>
  )
}
import React from 'react'
import { CFormTextarea } from '@coreui/react'

export const FloatingLabelsTextareaExample = () => {
  return (
    <CFormTextarea
      id="floatingTextarea"
      floatingLabel="Comments"
      placeholder="Leave a comment here"
    ></CFormTextarea>
  )
}

To set a custom height on your <CFormTextarea>, do not use the rows attribute. Instead, set an explicit height (either inline or via custom CSS).

import React from 'react'
import { CFormTextarea } from '@coreui/react'

export const FloatingLabelsTextarea2Example = () => {
  return (
    <CFormTextarea
      placeholder="Leave a comment here"
      id="floatingTextarea2"
      floatingLabel="Comments"
      style={{ height: '100px' }}
    ></CFormTextarea>
  )
}
import React from 'react'
import { CFormTextarea } from '@coreui/react'

export const FloatingLabelsTextarea2Example = () => {
  return (
    <CFormTextarea
      placeholder="Leave a comment here"
      id="floatingTextarea2"
      floatingLabel="Comments"
      style={{ height: '100px' }}
    ></CFormTextarea>
  )
}

Selects

Other than <CFormInput>, floating labels are only available on <CFormSelect>s. They work in the same way, but unlike <CFormInput>s, they’ll always show the <CFormLabel> in its floated state. Selects with size and multiple are not supported.

import React from 'react'
import { CFormSelect } from '@coreui/react'

export const FloatingLabelsSelectExample = () => {
  return (
    <CFormSelect
      id="floatingSelect"
      floatingLabel="Works with selects"
      aria-label="Floating label select example"
    >
      <option>Open this select menu</option>
      <option value="1">One</option>
      <option value="2">Two</option>
      <option value="3">Three</option>
    </CFormSelect>
  )
}
import React from 'react'
import { CFormSelect } from '@coreui/react'

export const FloatingLabelsSelectExample = () => {
  return (
    <CFormSelect
      id="floatingSelect"
      floatingLabel="Works with selects"
      aria-label="Floating label select example"
    >
      <option>Open this select menu</option>
      <option value="1">One</option>
      <option value="2">Two</option>
      <option value="3">Three</option>
    </CFormSelect>
  )
}

Layout

When working with the CoreUI for Bootstrap grid system, be sure to place form elements within column classes.

import React from 'react'
import { CCol, CFormInput, CFormSelect, CRow } from '@coreui/react'

export const FloatingLabelsLayoutExample = () => {
  return (
    <CRow xs={{ gutter: 2 }}>
      <CCol md>
        <CFormInput
          type="email"
          id="floatingInputGrid"
          floatingLabel="Email address"
          placeholder="[email protected]"
          defaultValue="[email protected]"
        />
      </CCol>
      <CCol md>
        <CFormSelect
          id="floatingSelectGrid"
          floatingLabel="Email address"
          aria-label="Works with selects"
        >
          <option>Open this select menu</option>
          <option value="1">One</option>
          <option value="2">Two</option>
          <option value="3">Three</option>
        </CFormSelect>
      </CCol>
    </CRow>
  )
}
import React from 'react'
import { CCol, CFormInput, CFormSelect, CRow } from '@coreui/react'

export const FloatingLabelsLayoutExample = () => {
  return (
    <CRow xs={{ gutter: 2 }}>
      <CCol md>
        <CFormInput
          type="email"
          id="floatingInputGrid"
          floatingLabel="Email address"
          placeholder="[email protected]"
          defaultValue="[email protected]"
        />
      </CCol>
      <CCol md>
        <CFormSelect
          id="floatingSelectGrid"
          floatingLabel="Email address"
          aria-label="Works with selects"
        >
          <option>Open this select menu</option>
          <option value="1">One</option>
          <option value="2">Two</option>
          <option value="3">Three</option>
        </CFormSelect>
      </CCol>
    </CRow>
  )
}

API

Check out the documentation below for a comprehensive guide to all the props you can use with the components mentioned here.